local jkHouses = ...

jkHouses:registerAssetProcessor("models/court_properties.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

jkHouses:registerAssetId("models/court_properties.fbx/Materials/logs", MOD_NS .. "LOGS_MATERIAL")
jkHouses:override({
    Id = MOD_NS .. "LOGS_MATERIAL",
    IsLighted = true,
	BackFaceVisible = true,
    HasShadow = true,
})

jkHouses:registerAssetId("models/court_properties.fbx/Materials/popies_3", MOD_NS .. "POPIES_MATERIAL")
jkHouses:override({
    Id = MOD_NS .. "POPIES_MATERIAL",
    IsLighted = true,
	BackFaceVisible = false,
    HasShadow = true,
})

jkHouses:registerAssetId("models/court_properties.fbx/Materials/transparent_roof", MOD_NS .. "TRANSPARENT_ROOF_2")
jkHouses:override({
    Id = MOD_NS .. "TRANSPARENT_ROOF_2",
	HasTransparency = true,
	HasAlphaTest = true,
	BackFaceVisible = true,
	HasShadow = true
})

jkHouses:registerAssetId("models/court_properties.fbx/Materials/chamomile", MOD_NS .. "CHAMOMILE_MATERIAL")
jkHouses:override({
    Id = MOD_NS .. "CHAMOMILE_MATERIAL",
	HasTransparency = true,
	HasAlphaTest = true,
	BackFaceVisible = false,
	HasShadow = false
})


function registerSmallProperty(path, name)
	local fbxPath = "models/court_properties.fbx/Prefab/" .. path
	jkHouses:registerAssetId(fbxPath, MOD_NS .. "PREFAB_" .. name)
	jkHouses:register({
		DataType = "BUILDING_PART",
		Id = MOD_NS .. name .."_PART",
		Name = MOD_NS .. name .."_NAME",
		Description = "",
		ConstructionVisual = MOD_NS .. "PREFAB_" .. name,
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = MOD_NS .. "PREFAB_" .. name
		},
		Cost = {
            BuildRightTaxes = {
                { Resource = "GOLD_COINS", Quantity = 5 }
            }
		}
	})
end


registerSmallProperty("LogsPart", "LOGS")
registerSmallProperty("Logs_2_Part", "LOGS_2")
registerSmallProperty("Logs_3_Part", "LOGS_3")
registerSmallProperty("ShedPart", "SHED")
registerSmallProperty("HeyStackPart", "HEY_STACK")
registerSmallProperty("SticksPart", "STICKS")
registerSmallProperty("Sticks_2_Part", "STICKS_2")
registerSmallProperty("CloversPart", "CLOVERS")
registerSmallProperty("PopiesPart", "POPIES")
registerSmallProperty("LadderPart", "LADDER")
registerSmallProperty("ChamomilePart", "CHAMOMILE")
registerSmallProperty("RocksPart", "ROCKS")

jkHouses:register({
	DataType = "BUILDING",
	Id = MOD_NS .. "BACKYARD_DECORATIONS",
	Name = MOD_NS .. "BACKYARD_DECORATIONS_NAME",
	BuildingType = BUILDING_TYPE.MONUMENT,
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "FIELD_DECORATIONS",
			BuildingPartList = {
				MOD_NS .. "POPIES_PART",
				MOD_NS .. "CLOVERS_PART",
				MOD_NS .. "CHAMOMILE_PART",
				MOD_NS .. "HEY_STACK_PART",
				MOD_NS .. "ROCKS_PART"
			}
		}, {
			Name = "BACKYARD_DECORATIONS",
			BuildingPartList = {
				MOD_NS .. "STICKS_PART",
				MOD_NS .. "STICKS_2_PART",
				MOD_NS .. "SHED_PART",
				MOD_NS .. "LOGS_PART",
				MOD_NS .. "LOGS_2_PART",
				MOD_NS .. "LOGS_3_PART",
				MOD_NS .. "LADDER_PART"
			}
		}
	},
	IsDestructible = true,
	IsEditable = true,
	IsClearTrees = true
})